Index: nicrealtek.c
===================================================================
--- nicrealtek.c	(revision 1250)
+++ nicrealtek.c	(working copy)
@@ -27,11 +27,12 @@
 #define PCI_VENDOR_ID_REALTEK	0x10ec
 #define PCI_VENDOR_ID_SMC1211	0x1113
 
-#define BIOS_ROM_ADDR		0xD4
-#define BIOS_ROM_DATA		0xD7
+int BIOS_ROM_ADDR, BIOS_ROM_DATA;
 
+
 const struct pcidev_status nics_realtek[] = {
 	{0x10ec, 0x8139, OK, "Realtek", "RTL8139/8139C/8139C+"},
+	{0x10ec, 0x8169, OK, "Realtek", "RTL8169"},
 	{},
 };
 
@@ -40,6 +41,8 @@
 	{},
 };
 
+static uint16_t id;
+
 int nicrealtek_init(void)
 {
 	get_io_perms();
@@ -49,6 +52,16 @@
 
 	buses_supported = CHIP_BUSTYPE_PARALLEL;
 
+	id = pcidev_dev->device_id;
+	if(id == 0x8139) {
+		BIOS_ROM_ADDR = 0xD4;
+		BIOS_ROM_DATA = 0xD7;
+	}
+	else {
+		BIOS_ROM_ADDR = 0x30;
+		BIOS_ROM_DATA = 0x33;
+	}
+
 	return 0;
 }
 
